- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Community.Crypto Collection Docs

# community.crypto.openssl_privatekey_convert module – Convert OpenSSL private keys

Note

This module is part of the community.crypto collection (version 2.10.0).

To install it, use: `ansible-galaxy collection install community.crypto`. You need further requirements to be able to use this module, see Requirements for details.

To use it in a playbook, specify: `community.crypto.openssl_privatekey_convert`.

New in community.crypto 2.1.0

- Synopsis

- Requirements

- Parameters

- Attributes

- See Also

- Examples

- Return Values

## Synopsis

- This module allows one to convert OpenSSL private keys.

- The default mode for the private key file will be `0600` if mode is not explicitly set.

## Requirements

The below requirements are needed on the host that executes this module.

- cryptography >= 1.2.3 (older versions might work as well)

## Parameters

Parameter | Comments
--- | ---
attributes aliases: attr string | The attributes the resulting filesystem object should have. To get supported flags look at the man page for chattr on the target system. This string should contain the attributes in the same order as the one displayed by lsattr. The `=` operator is assumed as default, otherwise `+` or `-` operators need to be included in the string.
backup boolean | Create a backup file including a timestamp so you can get the original private key back if you overwrote it with a new one by accident. Choices: `false` ← (default) `true`
dest_passphrase string | The passphrase for the private key to store.
dest_path path / required | Name of the file in which the generated TLS/SSL private key will be written. It will have `0600` mode if mode is not explicitly set.
format string / required | Determines which format the destination private key should be written in. Please note that not every key can be exported in any format, and that not every format supports encryption. Choices: `"pkcs1"` `"pkcs8"` `"raw"`
group string | Name of the group that should own the filesystem object, as would be fed to chown. When left unspecified, it uses the current group of the current user unless you are root, in which case it can preserve the previous ownership.
mode any | The permissions the resulting filesystem object should have. For those used to /usr/bin/chmod remember that modes are actually octal numbers. You must either add a leading zero so that Ansible’s YAML parser knows it is an octal number (like `0644` or `01777`) or quote it (like `'644'` or `'1777'`) so Ansible receives a string and can do its own conversion from string into number. Giving Ansible a number without following one of these rules will end up with a decimal number which will have unexpected results. As of Ansible 1.8, the mode may be specified as a symbolic mode (for example, `u+rwx` or `u=rw,g=r,o=r`). If `mode` is not specified and the destination filesystem object does not exist, the default `umask` on the system will be used when setting the mode for the newly created filesystem object. If `mode` is not specified and the destination filesystem object does exist, the mode of the existing filesystem object will be used. Specifying `mode` is the best way to ensure filesystem objects are created with the correct permissions. See CVE-2020-1736 for further details.
owner string | Name of the user that should own the filesystem object, as would be fed to chown. When left unspecified, it uses the current user unless you are root, in which case it can preserve the previous ownership.
selevel string | The level part of the SELinux filesystem object context. This is the MLS/MCS attribute, sometimes known as the `range`. When set to `_default`, it will use the `level` portion of the policy if available.
serole string | The role part of the SELinux filesystem object context. When set to `_default`, it will use the `role` portion of the policy if available.
setype string | The type part of the SELinux filesystem object context. When set to `_default`, it will use the `type` portion of the policy if available.
seuser string | The user part of the SELinux filesystem object context. By default it uses the `system` policy, where applicable. When set to `_default`, it will use the `user` portion of the policy if available.
src_content string | The content of the file containing the OpenSSL private key to convert. Exactly one of src_path or src_content must be specified.
src_passphrase string | The passphrase for the private key to load.
src_path path | Name of the file containing the OpenSSL private key to convert. Exactly one of src_path or src_content must be specified.
unsafe_writes boolean | Influence when to use atomic operation to prevent data corruption or inconsistent reads from the target filesystem object. By default this module uses atomic operations to prevent data corruption or inconsistent reads from the target filesystem objects, but sometimes systems are configured or just broken in ways that prevent this. One example is docker mounted filesystem objects, which cannot be updated atomically from inside the container and can only be written in an unsafe manner. This option allows Ansible to fall back to unsafe methods of updating filesystem objects when atomic operations fail (however, it doesn’t force Ansible to perform unsafe writes). IMPORTANT! Unsafe writes are subject to race conditions and can lead to data corruption. Choices: `false` ← (default) `true`

## Attributes

Attribute | Support | Description
--- | --- | ---
check_mode | Support: full | Can run in `check_mode` and return changed status prediction without modifying target.
diff_mode | Support: none | Will return details on what has changed (or possibly needs changing in `check_mode`), when in diff mode.
safe_file_operations | Support: full | Uses Ansible’s strict file operation functions to ensure proper permissions and avoid data corruption.

## See Also

See also

community.crypto.openssl_privatekey

  Generate OpenSSL private keys.

community.crypto.openssl_privatekey_pipe

  Generate OpenSSL private keys without disk access.

community.crypto.openssl_publickey

  Generate an OpenSSL public key from its private key.

## Examples

    - name: Convert private key to PKCS8 format with passphrase
      community.crypto.openssl_privatekey_convert:
        src_path: /etc/ssl/private/ansible.com.pem
        dest_path: /etc/ssl/private/ansible.com.key
        dest_passphrase: '{{ private_key_passphrase }}'
        format: pkcs8

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Description
--- | ---
backup_file string | Name of backup file created. Returned: changed and if backup is `true` Sample: `"/path/to/privatekey.pem.2019-03-09@11:22~"`

### Authors

- Felix Fontein (@felixfontein)

### Collection links

Issue Tracker Repository (Sources) Submit a bug report Request a feature Communication